Clipboard in EJ2 JavaScript Scheduler control

3 Mar 202524 minutes to read

The Clipboard functionality in the Syncfusion Scheduler control enhances scheduling efficiency by enabling users to cut, copy, and paste appointments with ease. This feature is especially beneficial for those managing multiple appointments, as it eliminates the need for repetitive data entry and allows users to quickly adjust their schedules without hassle.

To activate the clipboard feature in the scheduler, simply set the allowClipboard property to true.

Note: The allowKeyboardInteraction property must be true for proper functionality of the clipboard feature.

Cut, copy and paste using keyboard

The Syncfusion Scheduler control supports keyboard shortcuts to streamline the process of managing appointments.

These keyboard shortcuts enable users to efficiently manage their schedules:

Operation Shortcut Description
Copy Ctrl+C Duplicate appointments to streamline the scheduling process.
Cut Ctrl+X Move appointments to a new time slot without duplicates.
Paste Ctrl+V Place copied or cut appointments into the desired time slot.

To use these shortcuts, simply click on the appointment and press Ctrl+C to copy or Ctrl+X to cut. To paste the copied or cut appointment, click on the desired time slot and press Ctrl+V

var scheduleObj = new ej.schedule.Schedule({
    width: '100%',
    height: '550px',
    selectedDate: new Date(2024, 1, 15),
    eventSettings: {
        dataSource: scheduleData
    },
    allowClipboard: true,
    showQuickInfo: false
});
scheduleObj.appendTo('#Schedule');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Schedule Typescript Control</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Schedule Control">
    <meta name="author" content="Syncfusion">
    <link href="../index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-calendars/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-dropdowns/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-navigations/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-schedule/styles/material.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/29.1.33/dist/ej2.min.js" type="text/javascript"></script>
    <script src="es5-datasource.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    <div id="container">
        <div class="content-wrapper">
            <div id="Schedule">
            </div>
        </div>
    </div>

    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>
var scheduleData = [
    {
        Id: 1,
        Subject: 'Explosion of Betelgeuse Star',
        StartTime: new Date(2024, 1, 11, 9, 30),
        EndTime: new Date(2024, 1, 11, 11, 0),
        CategoryColor: '#1aaa55'
    }, {
        Id: 2,
        Subject: 'Thule Air Crash Report',
        StartTime: new Date(2024, 1, 12, 12, 0),
        EndTime: new Date(2024, 1, 12, 14, 0),
        CategoryColor: '#357cd2'
    }, {
        Id: 3,
        Subject: 'Blue Moon Eclipse',
        StartTime: new Date(2024, 1, 13, 9, 30),
        EndTime: new Date(2024, 1, 13, 11, 0),
        CategoryColor: '#7fa900'
    }, {
        Id: 4,
        Subject: 'Meteor Showers in 2024',
        StartTime: new Date(2024, 1, 14, 13, 0),
        EndTime: new Date(2024, 1, 14, 14, 30),
        CategoryColor: '#ea7a57'
    }, {
        Id: 5,
        Subject: 'Milky Way as Melting pot',
        StartTime: new Date(2024, 1, 15, 12, 0),
        EndTime: new Date(2024, 1, 15, 14, 0),
        CategoryColor: '#00bdae'
    }, {
        Id: 6,
        Subject: 'Mysteries of Bermuda Triangle',
        StartTime: new Date(2024, 1, 15, 9, 30),
        EndTime: new Date(2024, 1, 15, 11, 0),
        CategoryColor: '#f57f17'
    }, {
        Id: 7,
        Subject: 'Glaciers and Snowflakes',
        StartTime: new Date(2024, 1, 16, 11, 0),
        EndTime: new Date(2024, 1, 16, 12, 30),
        CategoryColor: '#1aaa55'
    }, {
        Id: 8,
        Subject: 'Life on Mars',
        StartTime: new Date(2024, 1, 17, 9, 0),
        EndTime: new Date(2024, 1, 17, 10, 0),
        CategoryColor: '#357cd2'
    }, {
        Id: 9,
        Subject: 'Alien Civilization',
        StartTime: new Date(2024, 1, 19, 11, 0),
        EndTime: new Date(2024, 1, 19, 13, 0),
        CategoryColor: '#7fa900'
    }, {
        Id: 10,
        Subject: 'Wildlife Galleries',
        StartTime: new Date(2024, 1, 21, 11, 0),
        EndTime: new Date(2024, 1, 21, 13, 0),
        CategoryColor: '#ea7a57'
    }, {
        Id: 11,
        Subject: 'Best Photography 2024',
        StartTime: new Date(2024, 1, 22, 9, 30),
        EndTime: new Date(2024, 1, 22, 11, 0),
        CategoryColor: '#00bdae'
    }, {
        Id: 12,
        Subject: 'Smarter Puppies',
        StartTime: new Date(2024, 1, 9, 10, 0),
        EndTime: new Date(2024, 1, 9, 11, 30),
        CategoryColor: '#f57f17'
    }, {
        Id: 13,
        Subject: 'Myths of Andromeda Galaxy',
        StartTime: new Date(2024, 1, 7, 10, 30),
        EndTime: new Date(2024, 1, 7, 12, 30),
        CategoryColor: '#1aaa55'
    }, {
        Id: 14,
        Subject: 'Aliens vs Humans',
        StartTime: new Date(2024, 1, 5, 10, 0),
        EndTime: new Date(2024, 1, 5, 11, 30),
        CategoryColor: '#357cd2'
    }, {
        Id: 15,
        Subject: 'Facts of Humming Birds',
        StartTime: new Date(2024, 1, 20, 9, 30),
        EndTime: new Date(2024, 1, 20, 11, 0),
        CategoryColor: '#7fa900'
    }, {
        Id: 16,
        Subject: 'Sky Gazers',
        StartTime: new Date(2024, 1, 23, 11, 0),
        EndTime: new Date(2024, 1, 23, 13, 0),
        CategoryColor: '#ea7a57'
    }, {
        Id: 17,
        Subject: 'The Cycle of Seasons',
        StartTime: new Date(2024, 1, 12, 5, 30),
        EndTime: new Date(2024, 1, 12, 7, 30),
        CategoryColor: '#00bdae'
    }, {
        Id: 18,
        Subject: 'Space Galaxies and Planets',
        StartTime: new Date(2024, 1, 12, 17, 0),
        EndTime: new Date(2024, 1, 12, 18, 30),
        CategoryColor: '#f57f17'
    }, {
        Id: 19,
        Subject: 'Lifecycle of Bumblebee',
        StartTime: new Date(2024, 1, 15, 6, 0),
        EndTime: new Date(2024, 1, 15, 7, 30),
        CategoryColor: '#7fa900'
    }, {
        Id: 20,
        Subject: 'Sky Gazers',
        StartTime: new Date(2024, 1, 15, 16, 0),
        EndTime: new Date(2024, 1, 15, 18, 0),
        CategoryColor: '#ea7a57'
    }
];

Note: For Mac users, use Cmd instead of Ctrl for copy, cut, and paste operations.

Cut, copy, and paste using context menu

You can programmatically manage appointments by using the public methods cut, copy, and paste. These methods allow you to perform the same actions as the context menu or external buttons.

Utilize these public methods to manage appointments programmatically in Syncfusion Schedule control:

Method Parameters Description
copy None Duplicate the selected appointment for reuse.
cut None Remove the selected appointment from its current slot for moving.
paste targetElement (Scheduler’s work-cell) Insert the copied or cut appointment into the specified time slot.

By using these methods, you can programmatically cut, copy, and paste appointments in the scheduler, providing more control over the appointment management process.

var scheduleObj = new ej.schedule.Schedule({
    width: '100%',
    height: '550px',
    views: [
        { option: 'Week' },
        { option: 'Day' },
        { option: 'Month' },
        { option: 'TimelineDay' },
        { option: 'TimelineWeek' },
        { option: 'TimelineWorkWeek' },
        { option: 'TimelineMonth' },
    ],
    currentView: 'Week',
    selectedDate: new Date(2024, 1, 15),
    allowClipboard: true,
    showQuickInfo: false,
    eventSettings: { dataSource: scheduleData },
    destroyed: function () {
        menuObj.destroy();
    },
});
scheduleObj.appendTo('#Schedule');

var selectedTargetEle;
var targetEle;
var menuObj;
var menuItems = [
    { text: 'Cut Event', iconCss: 'e-icons e-cut', id: 'Cut' },
    { text: 'Copy Event', iconCss: 'e-icons e-copy', id: 'Copy' },
    { text: 'Paste Event', iconCss: 'e-icons e-paste', id: 'Paste' }
];

menuObj = new ej.navigations.ContextMenu({
    target: '.e-schedule',
    items: menuItems,
    beforeOpen: contextMenuBeforeOpen,
    select: onMenuItemSelect,
    cssClass: 'schedule-clipboard-menu'
});
menuObj.appendTo('#ScheduleContextMenu');

function contextMenuBeforeOpen(args) {
    var newEventEle = document.querySelector('.e-new-event');
    if (newEventEle) {
        ej.base.remove(newEventEle);
    }
    scheduleObj.closeQuickInfoPopup();
    targetEle = args.event.target;
    if (ej.base.closest(targetEle, '.e-contextmenu')) {
        return;
    }
    selectedTargetEle = ej.base.closest(targetEle, '.e-appointment,.e-work-cells,' +
        '.e-vertical-view .e-date-header-wrap .e-all-day-cells,.e-vertical-view .e-date-header-wrap .e-header-cells');

    if (!selectedTargetEle) {
        args.cancel = true;
        return;
    }
    if (selectedTargetEle.classList.contains('e-appointment')) {
        menuObj.showItems(['Cut', 'Copy'], true);
        menuObj.hideItems(['Paste'], true);
    } else {
        menuObj.showItems(['Paste'], true);
        menuObj.hideItems(['Cut', 'Copy'], true);
    }
}


function onMenuItemSelect(args) {
    var selectedMenuItem = args.item.id;
    switch (selectedMenuItem) {
        case 'Cut':
            scheduleObj.cut([selectedTargetEle]);
            break;
        case 'Copy':
            scheduleObj.copy([selectedTargetEle]);
            break;
        case 'Paste':
            scheduleObj.paste(targetEle);
            break;
    }
}
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Schedule Typescript Control</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Schedule Control">
    <meta name="author" content="Syncfusion">
    <link href="../index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-calendars/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-dropdowns/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-navigations/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-schedule/styles/material.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/29.1.33/dist/ej2.min.js" type="text/javascript"></script>
    <script src="es5-datasource.js" type="text/javascript"></script>
    <style>
        .schedule-context-menu .e-menu-item .new::before {
            content: '\e7f9';
        }

        .schedule-context-menu .e-menu-item .edit::before {
            content: '\ea9a';
        }

        .schedule-context-menu .e-menu-item .recurrence::before {
            content: '\e308';
            font-weight: bold;
        }

        .schedule-context-menu .e-menu-item .today::before {
            content: '\e322';
        }

        .schedule-context-menu .e-menu-item .delete::before {
            content: '\e94a';
        }

        .schedule-context-menu ul .e-menu-item .e-menu-icon {
            font-size: 12px;
        }
    </style>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>

    <div id="container">
        <div class="content-wrapper">
            <div id="Schedule">
            </div>
            <ul id="ScheduleContextMenu"></ul>
        </div>
    </div>

    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>
var scheduleData = [
    {
        Id: 1,
        Subject: 'Explosion of Betelgeuse Star',
        StartTime: new Date(2024, 1, 11, 9, 30),
        EndTime: new Date(2024, 1, 11, 11, 0),
        CategoryColor: '#1aaa55'
    }, {
        Id: 2,
        Subject: 'Thule Air Crash Report',
        StartTime: new Date(2024, 1, 12, 12, 0),
        EndTime: new Date(2024, 1, 12, 14, 0),
        CategoryColor: '#357cd2'
    }, {
        Id: 3,
        Subject: 'Blue Moon Eclipse',
        StartTime: new Date(2024, 1, 13, 9, 30),
        EndTime: new Date(2024, 1, 13, 11, 0),
        CategoryColor: '#7fa900'
    }, {
        Id: 4,
        Subject: 'Meteor Showers in 2024',
        StartTime: new Date(2024, 1, 14, 13, 0),
        EndTime: new Date(2024, 1, 14, 14, 30),
        CategoryColor: '#ea7a57'
    }, {
        Id: 5,
        Subject: 'Milky Way as Melting pot',
        StartTime: new Date(2024, 1, 15, 12, 0),
        EndTime: new Date(2024, 1, 15, 14, 0),
        CategoryColor: '#00bdae'
    }, {
        Id: 6,
        Subject: 'Mysteries of Bermuda Triangle',
        StartTime: new Date(2024, 1, 15, 9, 30),
        EndTime: new Date(2024, 1, 15, 11, 0),
        CategoryColor: '#f57f17'
    }, {
        Id: 7,
        Subject: 'Glaciers and Snowflakes',
        StartTime: new Date(2024, 1, 16, 11, 0),
        EndTime: new Date(2024, 1, 16, 12, 30),
        CategoryColor: '#1aaa55'
    }, {
        Id: 8,
        Subject: 'Life on Mars',
        StartTime: new Date(2024, 1, 17, 9, 0),
        EndTime: new Date(2024, 1, 17, 10, 0),
        CategoryColor: '#357cd2'
    }, {
        Id: 9,
        Subject: 'Alien Civilization',
        StartTime: new Date(2024, 1, 19, 11, 0),
        EndTime: new Date(2024, 1, 19, 13, 0),
        CategoryColor: '#7fa900'
    }, {
        Id: 10,
        Subject: 'Wildlife Galleries',
        StartTime: new Date(2024, 1, 21, 11, 0),
        EndTime: new Date(2024, 1, 21, 13, 0),
        CategoryColor: '#ea7a57'
    }, {
        Id: 11,
        Subject: 'Best Photography 2024',
        StartTime: new Date(2024, 1, 22, 9, 30),
        EndTime: new Date(2024, 1, 22, 11, 0),
        CategoryColor: '#00bdae'
    }, {
        Id: 12,
        Subject: 'Smarter Puppies',
        StartTime: new Date(2024, 1, 9, 10, 0),
        EndTime: new Date(2024, 1, 9, 11, 30),
        CategoryColor: '#f57f17'
    }, {
        Id: 13,
        Subject: 'Myths of Andromeda Galaxy',
        StartTime: new Date(2024, 1, 7, 10, 30),
        EndTime: new Date(2024, 1, 7, 12, 30),
        CategoryColor: '#1aaa55'
    }, {
        Id: 14,
        Subject: 'Aliens vs Humans',
        StartTime: new Date(2024, 1, 5, 10, 0),
        EndTime: new Date(2024, 1, 5, 11, 30),
        CategoryColor: '#357cd2'
    }, {
        Id: 15,
        Subject: 'Facts of Humming Birds',
        StartTime: new Date(2024, 1, 20, 9, 30),
        EndTime: new Date(2024, 1, 20, 11, 0),
        CategoryColor: '#7fa900'
    }, {
        Id: 16,
        Subject: 'Sky Gazers',
        StartTime: new Date(2024, 1, 23, 11, 0),
        EndTime: new Date(2024, 1, 23, 13, 0),
        CategoryColor: '#ea7a57'
    }, {
        Id: 17,
        Subject: 'The Cycle of Seasons',
        StartTime: new Date(2024, 1, 12, 5, 30),
        EndTime: new Date(2024, 1, 12, 7, 30),
        CategoryColor: '#00bdae'
    }, {
        Id: 18,
        Subject: 'Space Galaxies and Planets',
        StartTime: new Date(2024, 1, 12, 17, 0),
        EndTime: new Date(2024, 1, 12, 18, 30),
        CategoryColor: '#f57f17'
    }, {
        Id: 19,
        Subject: 'Lifecycle of Bumblebee',
        StartTime: new Date(2024, 1, 15, 6, 0),
        EndTime: new Date(2024, 1, 15, 7, 30),
        CategoryColor: '#7fa900'
    }, {
        Id: 20,
        Subject: 'Sky Gazers',
        StartTime: new Date(2024, 1, 15, 16, 0),
        EndTime: new Date(2024, 1, 15, 18, 0),
        CategoryColor: '#ea7a57'
    }
];

Modifying content before pasting

You can modify the content of an appointment before pasting it by using beforePaste event accessing the appointment details and making necessary changes.

The following example demonstrates how to seamlessly copy and paste content from a grid to a scheduler. To do this, follow these steps:

  1. Select an Item: Click on an item in the grid.
  2. Copy the Details: Press Ctrl + C to copy the selected event details.
  3. Choose a Time Slot: Click on the desired time slot in the scheduler.
  4. Paste the Details: Press Ctrl + V to paste the copied appointment details into the selected time slot.

In this example, the beforePaste event can be utilized to intercept the event details before they are pasted. This allows you to modify the content as needed. Such modifications could include adjusting the time, adding notes, or altering other specifics of the appointment.

Note: Ensure that the field mapping matches with the fields in the scheduler.

var scheduleObj = new ej.schedule.Schedule({
    width: '100%',
    height: '550px',
    selectedDate: new Date(2024, 1, 15),
    eventSettings: {
        dataSource: scheduleData
    },
    allowClipboard: true,
    showQuickInfo: false,
    beforePaste: (args) => {
        if (typeof args.data === 'string') {
            const dataArray = args.data.split('\t');
            const result = {
                Id: dataArray[0],
                Subject: dataArray[1],
                StartTime: new Date(dataArray[4]).toISOString(),
                EndTime: new Date(new Date(dataArray[4]).getTime() + 60 * 60 * 1000).toISOString(),
                Location: dataArray[2],
                Description: dataArray[3]
            };
            args.data = [result];
        }
    }
});
scheduleObj.appendTo('#Schedule');

const gridData = [
    {
        OrderID: 10248, CustomerID: 'VINET', Role: 'Admin', EmployeeID: 5,
        ShipName: 'Vins et alcools Chevalier', ShipCity: 'Reims', ShipAddress: '59 rue de l Abbaye',
        ShipRegion: 'CJ', Mask: '1111', ShipPostalCode: '51100', ShipCountry: 'France', Freight: 32.38, Verified: !0,
        OrderDate: new Date('2024-01-01')
    },
    {
        OrderID: 10249, CustomerID: 'TOMSP', Role: 'Employee', EmployeeID: 6,
        ShipName: 'Toms Spezialitäten', ShipCity: 'Münster', ShipAddress: 'Luisenstr. 48',
        ShipRegion: 'CJ', Mask: '2222', ShipPostalCode: '44087', ShipCountry: 'Germany', Freight: 11.61, Verified: !1,
        OrderDate: new Date('2024-01-02')
    },
    {
        OrderID: 10250, CustomerID: 'HANAR', Role: 'Admin', EmployeeID: 4,
        ShipName: 'Hanari Carnes', ShipCity: 'Rio de Janeiro', ShipAddress: 'Rua do Paço, 67',
        ShipRegion: 'RJ', Mask: '3333', ShipPostalCode: '05454-876', ShipCountry: 'Brazil', Freight: 65.83, Verified: !0,
        OrderDate: new Date('2024-01-03')
    },
    {
        OrderID: 10251, CustomerID: 'VICTE', Role: 'Manager', EmployeeID: 3,
        ShipName: 'Victuailles en stock', ShipCity: 'Lyon', ShipAddress: '2, rue du Commerce',
        ShipRegion: 'CJ', Mask: '4444', ShipPostalCode: '69004', ShipCountry: 'France', Freight: 41.34, Verified: !0,
        OrderDate: new Date('2024-01-04')
    },
    {
        OrderID: 10252, CustomerID: 'SUPRD', Role: 'Manager', EmployeeID: 2,
        ShipName: 'Suprêmes délices', ShipCity: 'Charleroi', ShipAddress: 'Boulevard Tirou, 255',
        ShipRegion: 'CJ', Mask: '5555', ShipPostalCode: 'B-6000', ShipCountry: 'Belgium', Freight: 51.3, Verified: !0,
        OrderDate: new Date('2024-01-05')
    },
    {
        OrderID: 10253, CustomerID: 'HANAR', Role: 'Admin', EmployeeID: 7,
        ShipName: 'Hanari Carnes', ShipCity: 'Rio de Janeiro', ShipAddress: 'Rua do Paço, 67',
        ShipRegion: 'RJ', Mask: '6666', ShipPostalCode: '05454-876', ShipCountry: 'Brazil', Freight: 58.17, Verified: !0,
        OrderDate: new Date('2024-01-06')
    },
    {
        OrderID: 10254, CustomerID: 'CHOPS', Role: 'Employee', EmployeeID: 5,
        ShipName: 'Chop-suey Chinese', ShipCity: 'Bern', ShipAddress: 'Hauptstr. 31',
        ShipRegion: 'CJ', Mask: '7777', ShipPostalCode: '3012', ShipCountry: 'Switzerland', Freight: 22.98, Verified: !1,
        OrderDate: new Date('2024-01-07')
    }
];

const gridObj = new Grid({
    dataSource: gridData,
    allowSelection: true,
    height: 400,
    cssClass: 'drag-grid',
    width: '40%',
    columns: [
        { field: 'OrderID', headerText: 'Order ID', textAlign: 'Right', width: 90 },
        { field: 'CustomerID', headerText: 'Customer ID', width: 100 },
        { field: 'ShipCity', headerText: 'Ship City', width: 100 },
        { field: 'ShipName', headerText: 'Ship Name', width: 130 },
        { field: 'OrderDate', headerText: 'Order Date', type: 'date', format: 'yMd', width: 100 }
    ]
});
gridObj.appendTo('#Grid');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Schedule Typescript Control</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Schedule Control">
    <meta name="author" content="Syncfusion">
    <link href="../index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-calendars/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-dropdowns/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-navigations/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-schedule/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-grids/styles/bootstrap5.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-richtexteditor/styles/bootstrap5.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-lists/styles/bootstrap5.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-notifications/styles/bootstrap5.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-splitbuttons/styles/bootstrap5.css" rel="stylesheet" />
    <script src="https://cdn.syncfusion.com/ej2/29.1.33/dist/ej2.min.js" type="text/javascript"></script>
    <script src="es5-datasource.js" type="text/javascript"></script>

    <style type="text/css">
        .content-wrapper {
            display: flex;
            justify-content: space-between;
        }

        @media screen and (max-width: 540px) {
            .content-wrapper {
                flex-direction: column;
            }

            .e-grid {
                width: 100% !important;
            }
        }
    </style>

<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>

    <div id='container'>
        <div class="content-wrapper">
            <div id="Schedule"></div>
            <div id="Grid"></div>
        </div>
    </div>

    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>
var scheduleData = [
    {
        Id: 1,
        Subject: 'Explosion of Betelgeuse Star',
        StartTime: new Date(2024, 1, 11, 9, 30),
        EndTime: new Date(2024, 1, 11, 11, 0),
        CategoryColor: '#1aaa55'
    }, {
        Id: 2,
        Subject: 'Thule Air Crash Report',
        StartTime: new Date(2024, 1, 12, 12, 0),
        EndTime: new Date(2024, 1, 12, 14, 0),
        CategoryColor: '#357cd2'
    }, {
        Id: 3,
        Subject: 'Blue Moon Eclipse',
        StartTime: new Date(2024, 1, 13, 9, 30),
        EndTime: new Date(2024, 1, 13, 11, 0),
        CategoryColor: '#7fa900'
    }, {
        Id: 4,
        Subject: 'Meteor Showers in 2024',
        StartTime: new Date(2024, 1, 14, 13, 0),
        EndTime: new Date(2024, 1, 14, 14, 30),
        CategoryColor: '#ea7a57'
    }, {
        Id: 5,
        Subject: 'Milky Way as Melting pot',
        StartTime: new Date(2024, 1, 15, 12, 0),
        EndTime: new Date(2024, 1, 15, 14, 0),
        CategoryColor: '#00bdae'
    }, {
        Id: 6,
        Subject: 'Mysteries of Bermuda Triangle',
        StartTime: new Date(2024, 1, 15, 9, 30),
        EndTime: new Date(2024, 1, 15, 11, 0),
        CategoryColor: '#f57f17'
    }, {
        Id: 7,
        Subject: 'Glaciers and Snowflakes',
        StartTime: new Date(2024, 1, 16, 11, 0),
        EndTime: new Date(2024, 1, 16, 12, 30),
        CategoryColor: '#1aaa55'
    }, {
        Id: 8,
        Subject: 'Life on Mars',
        StartTime: new Date(2024, 1, 17, 9, 0),
        EndTime: new Date(2024, 1, 17, 10, 0),
        CategoryColor: '#357cd2'
    }, {
        Id: 9,
        Subject: 'Alien Civilization',
        StartTime: new Date(2024, 1, 19, 11, 0),
        EndTime: new Date(2024, 1, 19, 13, 0),
        CategoryColor: '#7fa900'
    }, {
        Id: 10,
        Subject: 'Wildlife Galleries',
        StartTime: new Date(2024, 1, 21, 11, 0),
        EndTime: new Date(2024, 1, 21, 13, 0),
        CategoryColor: '#ea7a57'
    }, {
        Id: 11,
        Subject: 'Best Photography 2024',
        StartTime: new Date(2024, 1, 22, 9, 30),
        EndTime: new Date(2024, 1, 22, 11, 0),
        CategoryColor: '#00bdae'
    }, {
        Id: 12,
        Subject: 'Smarter Puppies',
        StartTime: new Date(2024, 1, 9, 10, 0),
        EndTime: new Date(2024, 1, 9, 11, 30),
        CategoryColor: '#f57f17'
    }, {
        Id: 13,
        Subject: 'Myths of Andromeda Galaxy',
        StartTime: new Date(2024, 1, 7, 10, 30),
        EndTime: new Date(2024, 1, 7, 12, 30),
        CategoryColor: '#1aaa55'
    }, {
        Id: 14,
        Subject: 'Aliens vs Humans',
        StartTime: new Date(2024, 1, 5, 10, 0),
        EndTime: new Date(2024, 1, 5, 11, 30),
        CategoryColor: '#357cd2'
    }, {
        Id: 15,
        Subject: 'Facts of Humming Birds',
        StartTime: new Date(2024, 1, 20, 9, 30),
        EndTime: new Date(2024, 1, 20, 11, 0),
        CategoryColor: '#7fa900'
    }, {
        Id: 16,
        Subject: 'Sky Gazers',
        StartTime: new Date(2024, 1, 23, 11, 0),
        EndTime: new Date(2024, 1, 23, 13, 0),
        CategoryColor: '#ea7a57'
    }, {
        Id: 17,
        Subject: 'The Cycle of Seasons',
        StartTime: new Date(2024, 1, 12, 5, 30),
        EndTime: new Date(2024, 1, 12, 7, 30),
        CategoryColor: '#00bdae'
    }, {
        Id: 18,
        Subject: 'Space Galaxies and Planets',
        StartTime: new Date(2024, 1, 12, 17, 0),
        EndTime: new Date(2024, 1, 12, 18, 30),
        CategoryColor: '#f57f17'
    }, {
        Id: 19,
        Subject: 'Lifecycle of Bumblebee',
        StartTime: new Date(2024, 1, 15, 6, 0),
        EndTime: new Date(2024, 1, 15, 7, 30),
        CategoryColor: '#7fa900'
    }, {
        Id: 20,
        Subject: 'Sky Gazers',
        StartTime: new Date(2024, 1, 15, 16, 0),
        EndTime: new Date(2024, 1, 15, 18, 0),
        CategoryColor: '#ea7a57'
    }
];

You can refer to our JavaScript Scheduler feature tour page for its groundbreaking feature representations. You can also explore our JavaScript Scheduler example to knows how to present and manipulate data.

Clipboard in React Schedule component

17 Mar 202524 minutes to read

The Clipboard functionality in the Syncfusion® Schedule control enhances scheduling efficiency by enabling users to cut, copy, and paste appointments with ease. This feature is especially beneficial for those managing multiple appointments, as it eliminates the need for repetitive data entry and allows users to quickly adjust their schedules without hassle.
To activate the clipboard feature in the scheduler, simply set the allowClipboard property to true.

Note: The allowKeyboardInteraction property must be true for proper functionality of the clipboard feature.

Cut, copy and paste using keyboard

The Syncfusion® Schedule control supports keyboard shortcuts to streamline the process of managing appointments.

These keyboard shortcuts enable users to efficiently manage their schedules:

Operation Shortcut Description
Copy Ctrl+C Duplicate appointments to streamline the scheduling process.
Cut Ctrl+X Move appointments to a new time slot without duplicates.
Paste Ctrl+V Place copied or cut appointments into the desired time slot.

To use these shortcuts, simply click on the appointment and press Ctrl+C to copy or Ctrl+X to cut. To paste the copied or cut appointment, click on the desired time slot and press Ctrl+V

import { useRef } from 'react';
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import {
  ScheduleComponent, ViewsDirective, ViewDirective,
  Day, Week, WorkWeek, Month, Agenda, Inject
} from '@syncfusion/ej2-react-schedule';
import { scheduleData } from './datasource';


const App = () => {
  const scheduleObj = useRef(null);
  const eventSettings = { dataSource: scheduleData };

  return (
    <div className='schedule-control-section'>
      <div className='control-section'>
        <div className='control-wrapper'>
          <ScheduleComponent height='550px' ref={scheduleObj} selectedDate={new Date(2024, 1, 15)} eventSettings={eventSettings}
            allowClipboard={true} showQuickInfo={false} >
            <ViewsDirective>
              <ViewDirective option='Day' />
              <ViewDirective option='Week' />
              <ViewDirective option='WorkWeek' />
              <ViewDirective option='Month' />
              <ViewDirective option='Agenda' />
            </ViewsDirective>
            <Inject services={[Day, Week, WorkWeek, Month, Agenda]} />
          </ScheduleComponent>
        </div>
      </div>
    </div>
  );
};

const root = ReactDOM.createRoot(document.getElementById('schedule'));
root.render(<App />);
import { useRef } from 'react';
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import {
  ScheduleComponent, ViewsDirective, ViewDirective, CellClickEventArgs,
  Day, Week, WorkWeek, Month, Agenda, Inject
} from '@syncfusion/ej2-react-schedule';
import { scheduleData } from './datasource';

const App = () => {
  const scheduleObj = useRef<ScheduleComponent>(null);
  const eventSettings = { dataSource: scheduleData };

  return (
    <div className='schedule-control-section'>
      <div className='control-section'>
        <div className='control-wrapper'>
          <ScheduleComponent height='550px' ref={scheduleObj} selectedDate={new Date(2024, 1, 15)} eventSettings={eventSettings}
            allowClipboard={true} showQuickInfo={false}>
            <ViewsDirective>
              <ViewDirective option='Day' />
              <ViewDirective option='Week' />
              <ViewDirective option='WorkWeek' />
              <ViewDirective option='Month' />
              <ViewDirective option='Agenda' />
            </ViewsDirective>
            <Inject services={[Day, Week, WorkWeek, Month, Agenda]} />
          </ScheduleComponent>
        </div>
      </div>
    </div>
  );
};

const root = ReactDOM.createRoot(document.getElementById('schedule'));
root.render(<App />);
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Schedule</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-base/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-react-buttons/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-react-calendars/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-react-dropdowns/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-react-inputs/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-react-navigations/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-react-popups/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-react-schedule/styles/material.css" rel="stylesheet" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <link href="index.css" rel="stylesheet" />
    <script src="systemjs.config.js"></script>
    <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    <div id='schedule'>
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>

Note: For Mac users, use Cmd instead of Ctrl for copy, cut, and paste operations.

Cut, copy, and paste using context menu

You can programmatically manage appointments by using the public methods cut, copy, and paste. These methods allow you to perform the same actions as the context menu or external buttons.

Utilize these public methods to manage appointments programmatically in Syncfusion® Schedule control:

Method Parameters Description
copy None Duplicate the selected appointment for reuse.
cut None Remove the selected appointment from its current slot for moving.
paste targetElement (Scheduler’s work-cell) Insert the copied or cut appointment into the specified time slot.

By using these methods, you can programmatically cut, copy, and paste appointments in the scheduler, providing more control over the appointment management process.

import { useRef } from 'react';
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { closest, isNullOrUndefined, remove } from '@syncfusion/ej2-base';
import {
  ScheduleComponent, ViewsDirective, ViewDirective,
  Day, Week, WorkWeek, Month, Agenda, Inject
} from '@syncfusion/ej2-react-schedule';
import { ContextMenuComponent } from '@syncfusion/ej2-react-navigations';
import { scheduleData } from './datasource';


const App = () => {
  const scheduleObj = useRef(null);
  const menuObj = useRef(null);
  const eventSettings = { dataSource: scheduleData };

  let selectedTarget;
  let targetElement;
  const menuItems = [
    { text: 'Cut Event', iconCss: 'e-icons e-cut', id: 'Cut' },
    { text: 'Copy Event', iconCss: 'e-icons e-copy', id: 'Copy' },
    { text: 'Paste', iconCss: 'e-icons e-paste', id: 'Paste' }
  ];


  const onContextMenuBeforeOpen = (args) => {
    let newEventElement = document.querySelector('.e-new-event');
    if (newEventElement) {
      remove(newEventElement);
    }
    scheduleObj.current.closeQuickInfoPopup();
    targetElement = args.event.target;
    if (closest(targetElement, '.e-contextmenu')) {
      return;
    }
    selectedTarget = closest(targetElement, '.e-appointment,.e-work-cells,' +
      '.e-vertical-view .e-date-header-wrap .e-all-day-cells,.e-vertical-view .e-date-header-wrap .e-header-cells');
    if (isNullOrUndefined(selectedTarget)) {
      args.cancel = true;
      return;
    }
    if (selectedTarget.classList.contains('e-appointment')) {
      menuObj.current.showItems(['Cut', 'Copy'], true);
      menuObj.current.hideItems(['Paste'], true);
    } else {
      menuObj.current.showItems(['Paste'], true);
      menuObj.current.hideItems(['Cut', 'Copy'], true);
    }
  }

  const onMenuItemSelect = (args) => {
    let selectedMenuItem = args.item.id;
    switch (selectedMenuItem) {
      case 'Cut':
        scheduleObj.current.cut([selectedTarget]);
        break;
      case 'Copy':
        scheduleObj.current.copy([selectedTarget]);
        break;
      case 'Paste':
        scheduleObj.current.paste(targetElement);
        break;
    }
  }

  return (
    <div className='schedule-control-section'>
      <div className='control-section'>
        <div className='control-wrapper'>
          <ScheduleComponent height='550px' ref={scheduleObj} selectedDate={new Date(2024, 1, 15)} eventSettings={eventSettings}>
            <ViewsDirective>
              <ViewDirective option='Day' />
              <ViewDirective option='Week' />
              <ViewDirective option='WorkWeek' />
              <ViewDirective option='Month' />
              <ViewDirective option='Agenda' />
            </ViewsDirective>
            <Inject services={[Day, Week, WorkWeek, Month, Agenda]} />
          </ScheduleComponent>
        </div>
      </div>
      <ContextMenuComponent target='.e-schedule' items={menuItems}
        beforeOpen={onContextMenuBeforeOpen} select={onMenuItemSelect}
        cssClass='schedule-context-menu' ref={menuObj} />
    </div>
  );
};

const root = ReactDOM.createRoot(document.getElementById('schedule'));
root.render(<App />);
import { useRef } from 'react';
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { closest, isNullOrUndefined, remove } from '@syncfusion/ej2-base';
import {
  ScheduleComponent, ViewsDirective, ViewDirective,
  Day, Week, WorkWeek, Month, Agenda, Inject
} from '@syncfusion/ej2-react-schedule';
import { BeforeOpenCloseMenuEventArgs, MenuEventArgs, MenuItemModel, ContextMenuComponent } from '@syncfusion/ej2-react-navigations';
import { scheduleData } from './datasource';

const App = () => {
  const scheduleObj = useRef<ScheduleComponent>(null);
  const eventSettings = { dataSource: scheduleData };
  const menuObj = useRef<ContextMenuComponent>(null);
  let selectedTarget: Element;
  let targetElement: HTMLElement;
  const menuItems: MenuItemModel[] = [
    { text: 'Cut Event', iconCss: 'e-icons e-cut', id: 'Cut' },
    { text: 'Copy Event', iconCss: 'e-icons e-copy', id: 'Copy' },
    { text: 'Paste', iconCss: 'e-icons e-paste', id: 'Paste' }
  ];

  const onContextMenuBeforeOpen = (args: BeforeOpenCloseMenuEventArgs): void => {
    let newEventElement: HTMLElement = document.querySelector('.e-new-event') as HTMLElement;
    if (newEventElement) {
      remove(newEventElement);
    }
    scheduleObj.current.closeQuickInfoPopup();
    targetElement = args.event.target as HTMLElement;
    if (closest(targetElement, '.e-contextmenu')) {
      return;
    }
    selectedTarget = closest(targetElement, '.e-appointment,.e-work-cells,' +
      '.e-vertical-view .e-date-header-wrap .e-all-day-cells,.e-vertical-view .e-date-header-wrap .e-header-cells');
    if (isNullOrUndefined(selectedTarget)) {
      args.cancel = true;
      return;
    }
    if (selectedTarget.classList.contains('e-appointment')) {
      menuObj.current.showItems(['Cut', 'Copy'], true);
      menuObj.current.hideItems(['Paste'], true);
    } else {
      menuObj.current.showItems(['Paste'], true);
      menuObj.current.hideItems(['Cut', 'Copy'], true);
    }
  }

  const onMenuItemSelect = (args: MenuEventArgs): void => {
    let selectedMenuItem: string = args.item.id;
    switch (selectedMenuItem) {
      case 'Cut':
        scheduleObj.current.cut([selectedTarget] as HTMLElement[]);
        break;
      case 'Copy':
        scheduleObj.current.copy([selectedTarget] as HTMLElement[]);
        break;
      case 'Paste':
        scheduleObj.current.paste(targetElement);
        break;
    }
  }

  return (
    <div className='schedule-control-section'>
      <div className='control-section'>
        <div className='control-wrapper'>
          <ScheduleComponent height='550px' ref={scheduleObj} selectedDate={new Date(2024, 1, 15)} eventSettings={eventSettings}>
            <ViewsDirective>
              <ViewDirective option='Day' />
              <ViewDirective option='Week' />
              <ViewDirective option='WorkWeek' />
              <ViewDirective option='Month' />
              <ViewDirective option='Agenda' />
            </ViewsDirective>
            <Inject services={[Day, Week, WorkWeek, Month, Agenda]} />
          </ScheduleComponent>
        </div>
      </div>
      <ContextMenuComponent target='.e-schedule' items={menuItems}
        beforeOpen={onContextMenuBeforeOpen} select={onMenuItemSelect}
        cssClass='schedule-context-menu' ref={menuObj} />
    </div>
  );
};

const root = ReactDOM.createRoot(document.getElementById('schedule'));
root.render(<App />);
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Schedule</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-base/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-react-buttons/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-react-calendars/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-react-dropdowns/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-react-inputs/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-react-navigations/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-react-popups/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-react-schedule/styles/material.css" rel="stylesheet" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <link href="index.css" rel="stylesheet" />
    <script src="systemjs.config.js"></script>
    <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    <div id='schedule'>
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>
.schedule-context-menu .e-menu-item .new::before {
  content: '\e7f9';
}

.schedule-context-menu .e-menu-item .edit::before {
  content: '\ea9a';
}

.schedule-context-menu .e-menu-item .recurrence::before {
  content: '\e308';
  font-weight: bold;
}

.schedule-context-menu .e-menu-item .today::before {
  content: '\e322';
}

.schedule-context-menu .e-menu-item .delete::before {
  content: '\e94a';
}

.e-bigger .schedule-context-menu ul .e-menu-item .e-menu-icon {
  font-size: 14px;
}

.schedule-context-menu ul .e-menu-item .e-menu-icon {
  font-size: 12px;
}

Modifying Content before pasting

You can modify the content of an appointment before pasting it by using beforePaste event accessing the appointment details and making necessary changes.

The following example demonstrates how to seamlessly copy and paste content from a grid to a scheduler. To do this, follow these steps:

  1. Select an Item: Click on an item in the grid.
  2. Copy the Details: Press Ctrl + C to copy the selected event details.
  3. Choose a Time Slot: Click on the desired time slot in the scheduler.
  4. Paste the Details: Press Ctrl + V to paste the copied appointment details into the selected time slot.

In this example, the beforePaste event can be utilized to intercept the event details before they are pasted. This allows you to modify the content as needed. Such modifications could include adjusting the time, adding notes, or altering other specifics of the appointment.

Note: Ensure that the field mapping matches with the fields in the scheduler.

import { useRef } from 'react';
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import {
  ScheduleComponent, ViewsDirective, ViewDirective,
  Day, Week, WorkWeek, Month, Agenda, Inject, BeforePasteEventArgs
} from '@syncfusion/ej2-react-schedule';
import { scheduleData } from './datasource';
import { GridComponent, ColumnsDirective, ColumnDirective, RowDD, Edit } from "@syncfusion/ej2-react-grids";

const App = () => {
  const scheduleObj = useRef <ScheduleComponent> (null);
  let gridObj = useRef <GridComponent> (null);
  const eventSettings = { dataSource: scheduleData };
  const gridData = [
    {
      OrderID: 10248, CustomerID: 'VINET', Role: 'Admin', EmployeeID: 5,
      ShipName: 'Vins et alcools Chevalier', ShipCity: 'Reims', ShipAddress: '59 rue de l Abbaye',
      ShipRegion: 'CJ', Mask: '1111', ShipPostalCode: '51100', ShipCountry: 'France', Freight: 32.38, Verified: !0,
      OrderDate: new Date('2024-01-01')
    },
    {
      OrderID: 10249, CustomerID: 'TOMSP', Role: 'Employee', EmployeeID: 6,
      ShipName: 'Toms Spezialitäten', ShipCity: 'Münster', ShipAddress: 'Luisenstr. 48',
      ShipRegion: 'CJ', Mask: '2222', ShipPostalCode: '44087', ShipCountry: 'Germany', Freight: 11.61, Verified: !1,
      OrderDate: new Date('2024-01-02')
    },
    {
      OrderID: 10250, CustomerID: 'HANAR', Role: 'Admin', EmployeeID: 4,
      ShipName: 'Hanari Carnes', ShipCity: 'Rio de Janeiro', ShipAddress: 'Rua do Paço, 67',
      ShipRegion: 'RJ', Mask: '3333', ShipPostalCode: '05454-876', ShipCountry: 'Brazil', Freight: 65.83, Verified: !0,
      OrderDate: new Date('2024-01-03')
    },
    {
      OrderID: 10251, CustomerID: 'VICTE', Role: 'Manager', EmployeeID: 3,
      ShipName: 'Victuailles en stock', ShipCity: 'Lyon', ShipAddress: '2, rue du Commerce',
      ShipRegion: 'CJ', Mask: '4444', ShipPostalCode: '69004', ShipCountry: 'France', Freight: 41.34, Verified: !0,
      OrderDate: new Date('2024-01-04')
    },
    {
      OrderID: 10252, CustomerID: 'SUPRD', Role: 'Manager', EmployeeID: 2,
      ShipName: 'Suprêmes délices', ShipCity: 'Charleroi', ShipAddress: 'Boulevard Tirou, 255',
      ShipRegion: 'CJ', Mask: '5555', ShipPostalCode: 'B-6000', ShipCountry: 'Belgium', Freight: 51.3, Verified: !0,
      OrderDate: new Date('2024-01-05')
    },
    {
      OrderID: 10253, CustomerID: 'HANAR', Role: 'Admin', EmployeeID: 7,
      ShipName: 'Hanari Carnes', ShipCity: 'Rio de Janeiro', ShipAddress: 'Rua do Paço, 67',
      ShipRegion: 'RJ', Mask: '6666', ShipPostalCode: '05454-876', ShipCountry: 'Brazil', Freight: 58.17, Verified: !0,
      OrderDate: new Date('2024-01-06')
    },
    {
      OrderID: 10254, CustomerID: 'CHOPS', Role: 'Employee', EmployeeID: 5,
      ShipName: 'Chop-suey Chinese', ShipCity: 'Bern', ShipAddress: 'Hauptstr. 31',
      ShipRegion: 'CJ', Mask: '7777', ShipPostalCode: '3012', ShipCountry: 'Switzerland', Freight: 22.98, Verified: !1,
      OrderDate: new Date('2024-01-07')
    }
  ];
  const onBeforePasting = (args) => {
    if (typeof args.data === 'string') {
      const dataArray = args.data.split('\t');
      const result = {
        Id: dataArray[0],
        Subject: dataArray[1],
        StartTime: new Date(dataArray[4]).toISOString(),
        EndTime: new Date(new Date(dataArray[4]).getTime() + 60 * 60 * 1000).toISOString(),
        Location: dataArray[2],
        Description: dataArray[3]
      };
      args.data = [result];
    }
  }
  return (
    <div className='schedule-control-section'>
      <div className='control-section'>
        <div className='control-wrapper'>
          <ScheduleComponent height='550px' ref={scheduleObj} selectedDate={new Date(2024, 1, 15)} eventSettings={eventSettings}
            allowClipboard={true} showQuickInfo={false} beforePaste={onBeforePasting}>
            <ViewsDirective>
              <ViewDirective option='Day' />
              <ViewDirective option='Week' />
              <ViewDirective option='WorkWeek' />
              <ViewDirective option='Month' />
              <ViewDirective option='Agenda' />
            </ViewsDirective>
            <Inject services={[Day, Week, WorkWeek, Month, Agenda]} />
          </ScheduleComponent>
          <GridComponent dataSource={gridData} cssClass="drag-grid" width="40%" height="400px" allowSelection={true}
            ref={gridObj}  >
            <ColumnsDirective>
              <ColumnDirective field="OrderID" headerText="Order ID" textAlign="Right" width={90} />
              <ColumnDirective field="CustomerID" headerText="Customer ID" width={100} />
              <ColumnDirective field="ShipCity" headerText="Ship City" width={100} />
              <ColumnDirective field="ShipName" headerText="Ship Name" width={130} />
              <ColumnDirective field="OrderDate" headerText="Order Date" type="date" format="yMd" width={100} />
            </ColumnsDirective>
            <Inject services={[RowDD, Edit]} />
          </GridComponent>
        </div>
      </div>
    </div>
  );
};

const root = ReactDOM.createRoot(document.getElementById('schedule'));
root.render(<App />);
import { useRef } from 'react';
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import {
  ScheduleComponent, ViewsDirective, ViewDirective,
  Day, Week, WorkWeek, Month, Agenda, Inject, BeforePasteEventArgs
} from '@syncfusion/ej2-react-schedule';
import { scheduleData } from './datasource';
import { GridComponent, ColumnsDirective, ColumnDirective, RowDD, Edit } from "@syncfusion/ej2-react-grids";

const App = () => {
  interface ScheduleData {
    Id: string;
    Subject: string;
    StartTime: string;
    EndTime: string;
    Location: string;
    Description: string
  }
  const scheduleObj = useRef<ScheduleComponent>(null);
  let gridObj = useRef<GridComponent>(null);
  const eventSettings = { dataSource: scheduleData };
  const gridData: Object[] = [
    {
      OrderID: 10248, CustomerID: 'VINET', Role: 'Admin', EmployeeID: 5,
      ShipName: 'Vins et alcools Chevalier', ShipCity: 'Reims', ShipAddress: '59 rue de l Abbaye',
      ShipRegion: 'CJ', Mask: '1111', ShipPostalCode: '51100', ShipCountry: 'France', Freight: 32.38, Verified: !0,
      OrderDate: new Date('2024-01-01')
    },
    {
      OrderID: 10249, CustomerID: 'TOMSP', Role: 'Employee', EmployeeID: 6,
      ShipName: 'Toms Spezialitäten', ShipCity: 'Münster', ShipAddress: 'Luisenstr. 48',
      ShipRegion: 'CJ', Mask: '2222', ShipPostalCode: '44087', ShipCountry: 'Germany', Freight: 11.61, Verified: !1,
      OrderDate: new Date('2024-01-02')
    },
    {
      OrderID: 10250, CustomerID: 'HANAR', Role: 'Admin', EmployeeID: 4,
      ShipName: 'Hanari Carnes', ShipCity: 'Rio de Janeiro', ShipAddress: 'Rua do Paço, 67',
      ShipRegion: 'RJ', Mask: '3333', ShipPostalCode: '05454-876', ShipCountry: 'Brazil', Freight: 65.83, Verified: !0,
      OrderDate: new Date('2024-01-03')
    },
    {
      OrderID: 10251, CustomerID: 'VICTE', Role: 'Manager', EmployeeID: 3,
      ShipName: 'Victuailles en stock', ShipCity: 'Lyon', ShipAddress: '2, rue du Commerce',
      ShipRegion: 'CJ', Mask: '4444', ShipPostalCode: '69004', ShipCountry: 'France', Freight: 41.34, Verified: !0,
      OrderDate: new Date('2024-01-04')
    },
    {
      OrderID: 10252, CustomerID: 'SUPRD', Role: 'Manager', EmployeeID: 2,
      ShipName: 'Suprêmes délices', ShipCity: 'Charleroi', ShipAddress: 'Boulevard Tirou, 255',
      ShipRegion: 'CJ', Mask: '5555', ShipPostalCode: 'B-6000', ShipCountry: 'Belgium', Freight: 51.3, Verified: !0,
      OrderDate: new Date('2024-01-05')
    },
    {
      OrderID: 10253, CustomerID: 'HANAR', Role: 'Admin', EmployeeID: 7,
      ShipName: 'Hanari Carnes', ShipCity: 'Rio de Janeiro', ShipAddress: 'Rua do Paço, 67',
      ShipRegion: 'RJ', Mask: '6666', ShipPostalCode: '05454-876', ShipCountry: 'Brazil', Freight: 58.17, Verified: !0,
      OrderDate: new Date('2024-01-06')
    },
    {
      OrderID: 10254, CustomerID: 'CHOPS', Role: 'Employee', EmployeeID: 5,
      ShipName: 'Chop-suey Chinese', ShipCity: 'Bern', ShipAddress: 'Hauptstr. 31',
      ShipRegion: 'CJ', Mask: '7777', ShipPostalCode: '3012', ShipCountry: 'Switzerland', Freight: 22.98, Verified: !1,
      OrderDate: new Date('2024-01-07')
    }
  ];
  const onBeforePasting = (args: BeforePasteEventArgs) => {
    if (typeof args.data === 'string') {
      const dataArray: string[] = (args.data as string).split('\t');
      const result: ScheduleData = {
        Id: dataArray[0],
        Subject: dataArray[1],
        StartTime: new Date(dataArray[4]).toISOString(),
        EndTime: new Date(new Date(dataArray[4]).getTime() + 60 * 60 * 1000).toISOString(),
        Location: dataArray[2],
        Description: dataArray[3]
      };
      args.data = [result];
    }
  }
  return (
    <div className='schedule-control-section'>
      <div className='control-section'>
        <div className='control-wrapper'>
          <ScheduleComponent height='550px' ref={scheduleObj} selectedDate={new Date(2024, 1, 15)} eventSettings={eventSettings}
            allowClipboard={true} showQuickInfo={false} beforePaste={onBeforePasting}>
            <ViewsDirective>
              <ViewDirective option='Day' />
              <ViewDirective option='Week' />
              <ViewDirective option='WorkWeek' />
              <ViewDirective option='Month' />
              <ViewDirective option='Agenda' />
            </ViewsDirective>
            <Inject services={[Day, Week, WorkWeek, Month, Agenda]} />
          </ScheduleComponent>
          <GridComponent dataSource={gridData} cssClass="drag-grid" width="40%" height="400px" allowSelection={true}
            ref={gridObj}  >
            <ColumnsDirective>
              <ColumnDirective field="OrderID" headerText="Order ID" textAlign="Right" width={90} />
              <ColumnDirective field="CustomerID" headerText="Customer ID" width={100} />
              <ColumnDirective field="ShipCity" headerText="Ship City" width={100} />
              <ColumnDirective field="ShipName" headerText="Ship Name" width={130} />
              <ColumnDirective field="OrderDate" headerText="Order Date" type="date" format="yMd" width={100} />
            </ColumnsDirective>
            <Inject services={[RowDD, Edit]} />
          </GridComponent>
        </div>
      </div>
    </div>
  );
};

const root = ReactDOM.createRoot(document.getElementById('schedule'));
root.render(<App />);
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Schedule</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-base/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-buttons/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-calendars/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-dropdowns/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-inputs/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-navigations/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-popups/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-schedule/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-grids/styles/bootstrap5.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-richtexteditor/styles/bootstrap5.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-lists/styles/bootstrap5.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-notifications/styles/bootstrap5.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-splitbuttons/styles/bootstrap5.css" rel="stylesheet" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <link href="index.css" rel="stylesheet" />
    <script src="systemjs.config.js"></script>
    <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    <div id='schedule'>
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>
.schedule-control-section .control-wrapper {
    display: flex;
    justify-content: space-between;
}

@media screen and (max-width: 540px) {
    .schedule-control-section .control-wrapper {
        flex-direction: column;
    }

    .e-grid {
        width: 100% !important;
    }
}

You can refer to our React Scheduler feature tour page for its groundbreaking feature representations. You can also explore our React Scheduler example to knows how to present and manipulate data.

Clipboard in Vue Schedule component

25 Apr 202524 minutes to read

The Clipboard functionality in the Syncfusion® Schedule control enhances scheduling efficiency by enabling users to cut, copy, and paste appointments with ease. This feature is especially beneficial for those managing multiple appointments, as it eliminates the need for repetitive data entry and allows users to quickly adjust their schedules without hassle.
To activate the clipboard feature in the scheduler, simply set the allowClipboard property to true.

Note: The allowKeyboardInteraction property must be true for proper functionality of the clipboard feature.

Cut, copy and paste using keyboard

The Syncfusion® Schedule control supports keyboard shortcuts to streamline the process of managing appointments.

These keyboard shortcuts enable users to efficiently manage their schedules:

Operation Shortcut Description
Copy Ctrl+C Duplicate appointments to streamline the scheduling process.
Cut Ctrl+X Move appointments to a new time slot without duplicates.
Paste Ctrl+V Place copied or cut appointments into the desired time slot.

To use these shortcuts, simply click on the appointment and press Ctrl+C to copy or Ctrl+X to cut. To paste the copied or cut appointment, click on the desired time slot and press Ctrl+V

<template>
    <div id='app'>
        <div id='container'>
            <div class='content-wrapper'>
                <ejs-schedule id='Schedule' ref='scheduleObj' height='550px' :selectedDate='selectedDate'
                    :eventSettings='eventSettings' :allowClipboard="true" :showQuickInfo="false"></ejs-schedule>
            </div>
        </div>
    </div>
</template>

<script setup>
import { provide, ref } from "vue";
import { scheduleData } from './datasource.js';
import { extend } from '@syncfusion/ej2-base';
import { ScheduleComponent as EjsSchedule, Day, Week, WorkWeek, Month, Agenda } from '@syncfusion/ej2-vue-schedule';

const scheduleObj = ref(null);
const eventSettings = { dataSource: extend([], scheduleData, null, true) };
const selectedDate = new Date(2024, 1, 15);

provide('schedule', [Day, Week, WorkWeek, Month, Agenda]);

</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-calendars/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-dropdowns/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-inputs/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-schedule/styles/material.css";
</style>
<template>
    <div id='app'>
        <div id='container'>
            <div class='content-wrapper'>
                <ejs-schedule id='Schedule' ref='scheduleObj' height='550px' :selectedDate='selectedDate'
                    :eventSettings='eventSettings' :allowClipboard="true" :showQuickInfo="false"></ejs-schedule>
            </div>
        </div>
    </div>
</template>
<script>
import { scheduleData } from './datasource.js';
import { extend } from '@syncfusion/ej2-base';
import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda } from '@syncfusion/ej2-vue-schedule';

export default {
    name: "App",
    components: {
        "ejs-schedule": ScheduleComponent,
    },
    data: function () {
        return {
            eventSettings: { dataSource: extend([], scheduleData, null, true) },
            selectedDate: new Date(2024, 1, 15),
        }
    },
    provide: {
        schedule: [Day, Week, WorkWeek, Month, Agenda]
    },
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-calendars/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-dropdowns/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-inputs/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-schedule/styles/material.css";
</style>

Note: For Mac users, use Cmd instead of Ctrl for copy, cut, and paste operations.

Cut, copy, and paste using context menu

You can programmatically manage appointments by using the public methods cut, copy, and paste. These methods allow you to perform the same actions as the context menu or external buttons.

Utilize these public methods to manage appointments programmatically in Syncfusion® Schedule control:

Method Parameters Description
copy None Duplicate the selected appointment for reuse.
cut None Remove the selected appointment from its current slot for moving.
paste targetElement (Scheduler’s work-cell) Insert the copied or cut appointment into the specified time slot.

By using these methods, you can programmatically cut, copy, and paste appointments in the scheduler, providing more control over the appointment management process.

<template>
    <div id='app'>
        <div id='container'>
            <div class='content-wrapper'>
                <ejs-schedule id='Schedule' ref='scheduleObj' height='550px' :selectedDate='selectedDate'
                    :eventSettings='eventSettings' :allowClipboard=true :showQuickInfo="false"></ejs-schedule>
            </div>
            <div>
                <ejs-contextmenu id="ScheduleContextMenu" ref="menuObj" :target="'.e-schedule'" :items="menuItems"
                    :beforeOpen="onContextMenuBeforeOpen" :select="onMenuItemSelect"
                    :cssClass="schedule-context-menu"></ejs-contextmenu>
            </div>
        </div>
    </div>
</template>
<script setup>
import { provide, ref } from "vue";
import { scheduleData } from './datasource.js';
import { extend, closest, isNullOrUndefined, remove, removeClass } from '@syncfusion/ej2-base';
import { ScheduleComponent as EjsSchedule, Day, Week, WorkWeek, Month, Agenda } from '@syncfusion/ej2-vue-schedule';
import { ContextMenuComponent as EjsContextmenu } from '@syncfusion/ej2-vue-navigations';

const scheduleObj = ref(null);
const menuObj = ref(null);
const eventSettings = { dataSource: extend([], scheduleData, null, true) };
const selectedDate = new Date(2024, 1, 15);
const menuItems: [
    { text: 'Cut Event', iconCss: 'e-icons e-cut', id: 'Cut' },
    { text: 'Copy Event', iconCss: 'e-icons e-copy', id: 'Copy' },
    { text: 'Paste', iconCss: 'e-icons e-paste', id: 'Paste' }
];
const targetElement: null,
const selectedTarget = null;

const onContextMenuBeforeOpen = function (args) {
    let newEventElement = document.querySelector('.e-new-event');
    if (newEventElement) {
        remove(newEventElement);
    }
    this.$refs.scheduleObj.closeQuickInfoPopup();
    this.targetElement = args.event.target;
    if (closest(this.targetElement, '.e-contextmenu')) {
        return;
    }
    this.selectedTarget = closest(this.targetElement, '.e-appointment,.e-work-cells,' +
        '.e-vertical-view .e-date-header-wrap .e-all-day-cells,.e-vertical-view .e-date-header-wrap .e-header-cells');
    if (isNullOrUndefined(this.selectedTarget)) {
        args.cancel = true;
        return;
    }
    if (this.selectedTarget.classList.contains('e-appointment')) {
        this.$refs.menuObj.showItems(['Cut', 'Copy'], true);
        this.$refs.menuObj.hideItems(['Paste'], true);
    } else {
        this.$refs.menuObj.showItems(['Paste'], true);
        this.$refs.menuObj.hideItems(['Cut', 'Copy'], true);
    }
}
const onMenuItemSelect = function (args) {
    let selectedMenuItem = args.item.id;
    switch (selectedMenuItem) {
        case 'Cut':
            this.$refs.scheduleObj.cut([this.selectedTarget]);
            break;
        case 'Copy':
            this.$refs.scheduleObj.copy([this.selectedTarget]);
            break;
        case 'Paste':
            this.$refs.scheduleObj.paste(this.targetElement);
            break;
    }
}

provide('schedule', [Day, Week, WorkWeek, Month, Agenda]);

</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-calendars/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-dropdowns/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-inputs/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-schedule/styles/material.css";

.schedule-context-menu .e-menu-item .new::before {
    content: '\e7f9';
}

.schedule-context-menu .e-menu-item .edit::before {
    content: '\ea9a';
}

.schedule-context-menu .e-menu-item .recurrence::before {
    content: '\e308';
    font-weight: bold;
}

.schedule-context-menu .e-menu-item .today::before {
    content: '\e322';
}

.schedule-context-menu .e-menu-item .delete::before {
    content: '\e94a';
}

.e-bigger .schedule-context-menu ul .e-menu-item .e-menu-icon {
    font-size: 14px;
}

.schedule-context-menu ul .e-menu-item .e-menu-icon {
    font-size: 12px;
}

.schedule-context-menu .e-menu-parent.e-ul .e-menu-item {
    font-family: "Roboto", "Segoe UI", "GeezaPro", "DejaVu Serif", "sans-serif", "-apple-system", "BlinkMacSystemFont";
}
</style>
<template>
    <div id='app'>
        <div id='container'>
            <div class='content-wrapper'>
                <ejs-schedule id='Schedule' ref='scheduleObj' height='550px' :selectedDate='selectedDate'
                    :eventSettings='eventSettings' :allowClipboard=true :showQuickInfo="false"></ejs-schedule>
            </div>
            <div>
                <ejs-contextmenu id="ScheduleContextMenu" ref="menuObj" :target="'.e-schedule'" :items="menuItems"
                    :beforeOpen="onContextMenuBeforeOpen" :select="onMenuItemSelect"
                    :cssClass="schedule-context-menu"></ejs-contextmenu>
            </div>
        </div>
    </div>
</template>
<script>
import { scheduleData } from './datasource.js';
import { extend, closest, isNullOrUndefined, remove, removeClass } from '@syncfusion/ej2-base';
import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda } from '@syncfusion/ej2-vue-schedule';
import { ContextMenuComponent } from '@syncfusion/ej2-vue-navigations';

export default {
    name: "App",
    components: {
        "ejs-schedule": ScheduleComponent,
        "ejs-contextmenu": ContextMenuComponent
    },
    data: function () {
        return {
            eventSettings: { dataSource: extend([], scheduleData, null, true) },
            selectedDate: new Date(2024, 1, 15),
            menuItems: [
                { text: 'Cut Event', iconCss: 'e-icons e-cut', id: 'Cut' },
                { text: 'Copy Event', iconCss: 'e-icons e-copy', id: 'Copy' },
                { text: 'Paste', iconCss: 'e-icons e-paste', id: 'Paste' }
            ],
            selectedTarget: null,
            targetElement: null,
        }
    },
    provide: {
        schedule: [Day, Week, WorkWeek, Month, Agenda]
    },
    methods: {
        onContextMenuBeforeOpen: function (args) {
            let newEventElement = document.querySelector('.e-new-event');
            if (newEventElement) {
                remove(newEventElement);
            }
            this.$refs.scheduleObj.closeQuickInfoPopup();
            this.targetElement = args.event.target;
            if (closest(this.targetElement, '.e-contextmenu')) {
                return;
            }
            this.selectedTarget = closest(this.targetElement, '.e-appointment,.e-work-cells,' +
                '.e-vertical-view .e-date-header-wrap .e-all-day-cells,.e-vertical-view .e-date-header-wrap .e-header-cells');
            if (isNullOrUndefined(this.selectedTarget)) {
                args.cancel = true;
                return;
            }
            if (this.selectedTarget.classList.contains('e-appointment')) {
                this.$refs.menuObj.showItems(['Cut', 'Copy'], true);
                this.$refs.menuObj.hideItems(['Paste'], true);
            } else {
                this.$refs.menuObj.showItems(['Paste'], true);
                this.$refs.menuObj.hideItems(['Cut', 'Copy'], true);
            }
        },
        onMenuItemSelect: function (args) {
            let selectedMenuItem = args.item.id;
            switch (selectedMenuItem) {
                case 'Cut':
                    this.$refs.scheduleObj.cut([this.selectedTarget]);
                    break;
                case 'Copy':
                    this.$refs.scheduleObj.copy([this.selectedTarget]);
                    break;
                case 'Paste':
                    this.$refs.scheduleObj.paste(this.targetElement);
                    break;
            }
        }
    }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-calendars/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-dropdowns/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-inputs/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-schedule/styles/material.css";

.schedule-context-menu .e-menu-item .new::before {
    content: '\e7f9';
}

.schedule-context-menu .e-menu-item .edit::before {
    content: '\ea9a';
}

.schedule-context-menu .e-menu-item .recurrence::before {
    content: '\e308';
    font-weight: bold;
}

.schedule-context-menu .e-menu-item .today::before {
    content: '\e322';
}

.schedule-context-menu .e-menu-item .delete::before {
    content: '\e94a';
}

.e-bigger .schedule-context-menu ul .e-menu-item .e-menu-icon {
    font-size: 14px;
}

.schedule-context-menu ul .e-menu-item .e-menu-icon {
    font-size: 12px;
}

.schedule-context-menu .e-menu-parent.e-ul .e-menu-item {
    font-family: "Roboto", "Segoe UI", "GeezaPro", "DejaVu Serif", "sans-serif", "-apple-system", "BlinkMacSystemFont";
}
</style>

Modifying content before pasting

You can modify the content of an appointment before pasting it by using beforePaste event accessing the appointment details and making necessary changes.

The following example demonstrates how to seamlessly copy and paste content from a grid to a scheduler. To do this, follow these steps:

  1. Select an Item: Click on an item in the grid.
  2. Copy the Details: Press Ctrl + C to copy the selected event details.
  3. Choose a Time Slot: Click on the desired time slot in the scheduler.
  4. Paste the Details: Press Ctrl + V to paste the copied appointment details into the selected time slot.

In this example, the beforePaste event can be utilized to intercept the event details before they are pasted. This allows you to modify the content as needed. Such modifications could include adjusting the time, adding notes, or altering other specifics of the appointment.

Note: Ensure that the field mapping matches with the fields in the scheduler.

<template>
    <div id='app'>
        <div id='container'>
            <div class='content-wrapper'>
                <ejs-schedule id='Schedule' ref='scheduleObj' height='550px' :selectedDate='selectedDate'
                    :eventSettings='eventSettings' :allowClipboard="true" :showQuickInfo="false"
                    :beforePaste="onBeforePaste"></ejs-schedule>

                <ejs-grid id="Grid" ref="GridObj" width="40%" height="400px" :dataSource="gridData"
                    :cssClass="'drag-grid'" :allowSelection="true">
                    <e-columns>
                        <e-column field="OrderID" headerText="Order ID" textAlign="Right" width="90"></e-column>
                        <e-column field="CustomerID" headerText="Customer ID" width="100"></e-column>
                        <e-column field="ShipCity" headerText="Ship City" width="100"></e-column>
                        <e-column field="ShipName" headerText="Ship Name" width="130"></e-column>
                        <e-column field="OrderDate" headerText="Order Date" type="date" format="yMd" width="100"></e-column>
                    </e-columns>
                </ejs-grid>
            </div>
        </div>
    </div>
</template>

<script setup>
import { provide, ref } from "vue";
import { scheduleData } from './datasource.js';
import { extend } from '@syncfusion/ej2-base';
import { ScheduleComponent as EjsSchedule, Day, Week, WorkWeek, Month, Agenda } from '@syncfusion/ej2-vue-schedule';
import { GridComponent as EjsGrid, ColumnsDirective as EColumns, ColumnDirective as EColumn } from "@syncfusion/ej2-vue-grids";


const scheduleObj = ref(null);
const eventSettings = { dataSource: extend([], scheduleData, null, true) };
const selectedDate = new Date(2024, 1, 15);
const gridData = [
    {
        OrderID: 10248, CustomerID: 'VINET', Role: 'Admin', EmployeeID: 5,
        ShipName: 'Vins et alcools Chevalier', ShipCity: 'Reims', ShipAddress: '59 rue de l Abbaye',
        ShipRegion: 'CJ', Mask: '1111', ShipPostalCode: '51100', ShipCountry: 'France', Freight: 32.38, Verified: !0,
        OrderDate: new Date('2024-01-01')
    },
    {
        OrderID: 10249, CustomerID: 'TOMSP', Role: 'Employee', EmployeeID: 6,
        ShipName: 'Toms Spezialitäten', ShipCity: 'Münster', ShipAddress: 'Luisenstr. 48',
        ShipRegion: 'CJ', Mask: '2222', ShipPostalCode: '44087', ShipCountry: 'Germany', Freight: 11.61, Verified: !1,
        OrderDate: new Date('2024-01-02')
    },
    {
        OrderID: 10250, CustomerID: 'HANAR', Role: 'Admin', EmployeeID: 4,
        ShipName: 'Hanari Carnes', ShipCity: 'Rio de Janeiro', ShipAddress: 'Rua do Paço, 67',
        ShipRegion: 'RJ', Mask: '3333', ShipPostalCode: '05454-876', ShipCountry: 'Brazil', Freight: 65.83, Verified: !0,
        OrderDate: new Date('2024-01-03')
    },
    {
        OrderID: 10251, CustomerID: 'VICTE', Role: 'Manager', EmployeeID: 3,
        ShipName: 'Victuailles en stock', ShipCity: 'Lyon', ShipAddress: '2, rue du Commerce',
        ShipRegion: 'CJ', Mask: '4444', ShipPostalCode: '69004', ShipCountry: 'France', Freight: 41.34, Verified: !0,
        OrderDate: new Date('2024-01-04')
    },
    {
        OrderID: 10252, CustomerID: 'SUPRD', Role: 'Manager', EmployeeID: 2,
        ShipName: 'Suprêmes délices', ShipCity: 'Charleroi', ShipAddress: 'Boulevard Tirou, 255',
        ShipRegion: 'CJ', Mask: '5555', ShipPostalCode: 'B-6000', ShipCountry: 'Belgium', Freight: 51.3, Verified: !0,
        OrderDate: new Date('2024-01-05')
    },
    {
        OrderID: 10253, CustomerID: 'HANAR', Role: 'Admin', EmployeeID: 7,
        ShipName: 'Hanari Carnes', ShipCity: 'Rio de Janeiro', ShipAddress: 'Rua do Paço, 67',
        ShipRegion: 'RJ', Mask: '6666', ShipPostalCode: '05454-876', ShipCountry: 'Brazil', Freight: 58.17, Verified: !0,
        OrderDate: new Date('2024-01-06')
    },
    {
        OrderID: 10254, CustomerID: 'CHOPS', Role: 'Employee', EmployeeID: 5,
        ShipName: 'Chop-suey Chinese', ShipCity: 'Bern', ShipAddress: 'Hauptstr. 31',
        ShipRegion: 'CJ', Mask: '7777', ShipPostalCode: '3012', ShipCountry: 'Switzerland', Freight: 22.98, Verified: !1,
        OrderDate: new Date('2024-01-07')
    }
];

const onBeforePaste = function (args) {
    if (typeof args.data === 'string') {
        const dataArray = (args.data).split('\t');
        const result = {
            Id: dataArray[0],
            Subject: dataArray[1],
            StartTime: new Date(dataArray[4]).toISOString(),
            EndTime: new Date(new Date(dataArray[4]).getTime() + 60 * 60 * 1000).toISOString(),
            Location: dataArray[2],
            Description: dataArray[3]
        };
        args.data = [result];
    }
}
provide('schedule', [Day, Week, WorkWeek, Month, Agenda]);

</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-calendars/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-dropdowns/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-inputs/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-schedule/styles/material.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-grids/styles/material.css";

.content-wrapper {
    display: flex;
    justify-content: space-between;
}

@media screen and (max-width: 540px) {
    .content-wrapper {
        flex-direction: column;
    }

    .e-grid {
        width: 100% !important;
    }
}
</style>
<template>
    <div id='app'>
        <div id='container'>
            <div class='content-wrapper'>
                <ejs-schedule id='Schedule' ref='scheduleObj' height='550px' :selectedDate='selectedDate'
                    :eventSettings='eventSettings' :allowClipboard="true" :showQuickInfo="false"
                    :beforePaste="onBeforePaste"></ejs-schedule>

                <ejs-grid id="Grid" ref="GridObj" width="40%" height="400px" :dataSource="gridData"
                    :cssClass="'drag-grid'" :allowSelection="true">
                    <e-columns>
                        <e-column field="OrderID" headerText="Order ID" textAlign="Right" width="90"></e-column>
                        <e-column field="CustomerID" headerText="Customer ID" width="100"></e-column>
                        <e-column field="ShipCity" headerText="Ship City" width="100"></e-column>
                        <e-column field="ShipName" headerText="Ship Name" width="130"></e-column>
                        <e-column field="OrderDate" headerText="Order Date" type="date" format="yMd" width="100"></e-column>
                    </e-columns>
                </ejs-grid>
            </div>
        </div>
    </div>
</template>
<script>
import { scheduleData } from './datasource.js';
import { extend } from '@syncfusion/ej2-base';
import { ScheduleComponent, Day, Week, WorkWeek, Month, Agenda } from '@syncfusion/ej2-vue-schedule';
import { GridComponent, ColumnsDirective, ColumnDirective } from "@syncfusion/ej2-vue-grids";

export default {
    name: "App",
    components: {
        "ejs-schedule": ScheduleComponent,
        "ejs-grid": GridComponent,
        "e-columns": ColumnsDirective,
        "e-column": ColumnDirective

    },
    data: function () {
        return {
            eventSettings: { dataSource: extend([], scheduleData, null, true) },
            selectedDate: new Date(2024, 1, 15),
            gridData: [
                {
                    OrderID: 10248, CustomerID: 'VINET', Role: 'Admin', EmployeeID: 5,
                    ShipName: 'Vins et alcools Chevalier', ShipCity: 'Reims', ShipAddress: '59 rue de l Abbaye',
                    ShipRegion: 'CJ', Mask: '1111', ShipPostalCode: '51100', ShipCountry: 'France', Freight: 32.38, Verified: !0,
                    OrderDate: new Date('2024-01-01')
                },
                {
                    OrderID: 10249, CustomerID: 'TOMSP', Role: 'Employee', EmployeeID: 6,
                    ShipName: 'Toms Spezialitäten', ShipCity: 'Münster', ShipAddress: 'Luisenstr. 48',
                    ShipRegion: 'CJ', Mask: '2222', ShipPostalCode: '44087', ShipCountry: 'Germany', Freight: 11.61, Verified: !1,
                    OrderDate: new Date('2024-01-02')
                },
                {
                    OrderID: 10250, CustomerID: 'HANAR', Role: 'Admin', EmployeeID: 4,
                    ShipName: 'Hanari Carnes', ShipCity: 'Rio de Janeiro', ShipAddress: 'Rua do Paço, 67',
                    ShipRegion: 'RJ', Mask: '3333', ShipPostalCode: '05454-876', ShipCountry: 'Brazil', Freight: 65.83, Verified: !0,
                    OrderDate: new Date('2024-01-03')
                },
                {
                    OrderID: 10251, CustomerID: 'VICTE', Role: 'Manager', EmployeeID: 3,
                    ShipName: 'Victuailles en stock', ShipCity: 'Lyon', ShipAddress: '2, rue du Commerce',
                    ShipRegion: 'CJ', Mask: '4444', ShipPostalCode: '69004', ShipCountry: 'France', Freight: 41.34, Verified: !0,
                    OrderDate: new Date('2024-01-04')
                },
                {
                    OrderID: 10252, CustomerID: 'SUPRD', Role: 'Manager', EmployeeID: 2,
                    ShipName: 'Suprêmes délices', ShipCity: 'Charleroi', ShipAddress: 'Boulevard Tirou, 255',
                    ShipRegion: 'CJ', Mask: '5555', ShipPostalCode: 'B-6000', ShipCountry: 'Belgium', Freight: 51.3, Verified: !0,
                    OrderDate: new Date('2024-01-05')
                },
                {
                    OrderID: 10253, CustomerID: 'HANAR', Role: 'Admin', EmployeeID: 7,
                    ShipName: 'Hanari Carnes', ShipCity: 'Rio de Janeiro', ShipAddress: 'Rua do Paço, 67',
                    ShipRegion: 'RJ', Mask: '6666', ShipPostalCode: '05454-876', ShipCountry: 'Brazil', Freight: 58.17, Verified: !0,
                    OrderDate: new Date('2024-01-06')
                },
                {
                    OrderID: 10254, CustomerID: 'CHOPS', Role: 'Employee', EmployeeID: 5,
                    ShipName: 'Chop-suey Chinese', ShipCity: 'Bern', ShipAddress: 'Hauptstr. 31',
                    ShipRegion: 'CJ', Mask: '7777', ShipPostalCode: '3012', ShipCountry: 'Switzerland', Freight: 22.98, Verified: !1,
                    OrderDate: new Date('2024-01-07')
                }
            ]
        }
    },
    methods: {
        onBeforePaste(args) {
            if (typeof args.data === 'string') {
                const dataArray = (args.data).split('\t');
                const result = {
                    Id: dataArray[0],
                    Subject: dataArray[1],
                    StartTime: new Date(dataArray[4]).toISOString(),
                    EndTime: new Date(new Date(dataArray[4]).getTime() + 60 * 60 * 1000).toISOString(),
                    Location: dataArray[2],
                    Description: dataArray[3]
                };
                args.data = [result];
            }
        }
    },
    provide: {
        schedule: [Day, Week, WorkWeek, Month, Agenda]
    },
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-calendars/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-dropdowns/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-inputs/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-schedule/styles/material.css";


.content-wrapper {
    display: flex;
    justify-content: space-between;
}

@media screen and (max-width: 540px) {
    .content-wrapper {
        flex-direction: column;
    }

    .e-grid {
        width: 100% !important;
    }
}
</style>

You can refer to our Vue Scheduler feature tour page for its groundbreaking feature representations. You can also explore our Vue Scheduler example to knows how to present and manipulate data.

Clipboard in Angular Schedule component

5 Apr 202524 minutes to read

The Clipboard functionality in the Syncfusion® Schedule control enhances scheduling efficiency by enabling users to cut, copy, and paste appointments with ease. This feature is especially beneficial for those managing multiple appointments, as it eliminates the need for repetitive data entry and allows users to quickly adjust their schedules without hassle.
To activate the clipboard feature in the scheduler, simply set the allowClipboard property to true.

Note: The allowKeyboardInteraction property must be true for proper functionality of the clipboard feature.

Cut, copy and paste using keyboard

The Syncfusion® Schedule control supports keyboard shortcuts to streamline the process of managing appointments.

These keyboard shortcuts enable users to efficiently manage their schedules:

Operation Shortcut Description
Copy Ctrl+C Duplicate appointments to streamline the scheduling process.
Cut Ctrl+X Move appointments to a new time slot without duplicates.
Paste Ctrl+V Place copied or cut appointments into the desired time slot.

To use these shortcuts, simply click on the appointment and press Ctrl+C to copy or Ctrl+X to cut. To paste the copied or cut appointment, click on the desired time slot and press Ctrl+V

<ejs-schedule #scheduleObj height='550px' [selectedDate]="selectedDate" [allowResizing]="allowResizing"
    [allowDragAndDrop]="allowDragDrop" [eventSettings]="eventSettings" [allowClipboard]="true" [showQuickInfo]="false">
</ejs-schedule>
import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ScheduleModule } from '@syncfusion/ej2-angular-schedule'
import { ButtonModule } from '@syncfusion/ej2-angular-buttons'
import { ContextMenuModule } from '@syncfusion/ej2-angular-navigations'
import { Component, ViewChild, ViewEncapsulation } from '@angular/core';
import { extend } from '@syncfusion/ej2-base';
import {
    EventSettingsModel, DayService, WeekService, WorkWeekService, MonthService, AgendaService, ScheduleComponent, MonthAgendaService
} from '@syncfusion/ej2-angular-schedule';
import { scheduleData } from './datasource';

@Component({
    imports: [
        ScheduleModule,
        ButtonModule,
        ContextMenuModule
    ],
    standalone: true,
    selector: 'app-root',
    templateUrl: './app.component.html',
    providers: [DayService, WeekService, WorkWeekService, MonthService, AgendaService, MonthAgendaService],
    styleUrls: ['./index.css'],
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild('scheduleObj')
    public scheduleObj?: ScheduleComponent;
    public allowResizing: Boolean = false;
    public allowDragDrop: Boolean = false;
    public selectedDate: Date = new Date(2024, 1, 15);
    public eventSettings: EventSettingsModel = { dataSource: <Object[]>extend([], scheduleData, undefined, true) };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Note: For Mac users, use Cmd instead of Ctrl for copy, cut, and paste operations.

Cut, copy, and paste using context menu

You can programmatically manage appointments by using the public methods cut, copy, and paste. These methods allow you to perform the same actions as the context menu or external buttons.

Utilize these public methods to manage appointments programmatically in Syncfusion® Schedule control:

Method Parameters Description
copy None Duplicate the selected appointment for reuse.
cut None Remove the selected appointment from its current slot for moving.
paste targetElement (Scheduler’s work-cell) Insert the copied or cut appointment into the specified time slot.

By using these methods, you can programmatically cut, copy, and paste appointments in the scheduler, providing more control over the appointment management process.

<ejs-schedule #scheduleObj height='550px' [selectedDate]="selectedDate" [allowResizing]="allowResizing"
    [allowDragAndDrop]="allowDragDrop" [allowClipboard]="true" [showQuickInfo]="false" [eventSettings]="eventSettings">
</ejs-schedule>
<ejs-contextmenu #menuObj cssClass='schedule-context-menu' target='.e-schedule' [items]='menuItems'
    (beforeOpen)='onContextMenuBeforeOpen($event)' (select)='onMenuItemSelect($event)'></ejs-contextmenu>
import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ScheduleModule } from '@syncfusion/ej2-angular-schedule'
import { ButtonModule } from '@syncfusion/ej2-angular-buttons'
import { ContextMenuModule } from '@syncfusion/ej2-angular-navigations'
import { Component, ViewChild, ViewEncapsulation } from '@angular/core';
import { extend, closest, isNullOrUndefined, remove } from '@syncfusion/ej2-base';
import {
    EventSettingsModel, DayService, WeekService, WorkWeekService, MonthService, AgendaService, ScheduleComponent, MonthAgendaService
} from '@syncfusion/ej2-angular-schedule';
import { ContextMenuComponent, MenuItemModel, BeforeOpenCloseMenuEventArgs, MenuEventArgs } from '@syncfusion/ej2-angular-navigations';
import { scheduleData } from './datasource';

@Component({
    imports: [
        ScheduleModule,
        ButtonModule,
        ContextMenuModule
    ],
    standalone: true,
    selector: 'app-root',
    templateUrl: './app.component.html',
    providers: [DayService, WeekService, WorkWeekService, MonthService, AgendaService, MonthAgendaService],
    styleUrls: ['./index.css'],
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild('scheduleObj') public scheduleObj!: ScheduleComponent;
    @ViewChild('menuObj') public menuObj!: ContextMenuComponent;
    public allowResizing: Boolean = false;
    public allowDragDrop: Boolean = false;
    public selectedDate: Date = new Date(2024, 1, 15);
    public eventSettings: EventSettingsModel = { dataSource: <Object[]>extend([], scheduleData, undefined, true) };
    public selectedTarget!: Element;
    public targetElement!: HTMLElement;
    public menuItems: MenuItemModel[] = [
        { text: 'Cut Event', iconCss: 'e-icons e-cut', id: 'Cut' },
        { text: 'Copy Event', iconCss: 'e-icons e-copy', id: 'Copy' },
        { text: 'Paste', iconCss: 'e-icons e-paste', id: 'Paste' }
    ];

    public onContextMenuBeforeOpen(args: BeforeOpenCloseMenuEventArgs): void {
        const newEventElement: HTMLElement = document.querySelector('.e-new-event') as HTMLElement;
        if (newEventElement) {
            remove(newEventElement);
        }
        this.scheduleObj.closeQuickInfoPopup();
        this.targetElement = args.event.target as HTMLElement;
        if (closest(this.targetElement, '.e-contextmenu')) {
            return;
        }
        this.selectedTarget = closest(this.targetElement, '.e-appointment,.e-work-cells,' +
            '.e-vertical-view .e-date-header-wrap .e-all-day-cells,.e-vertical-view .e-date-header-wrap .e-header-cells');
        if (isNullOrUndefined(this.selectedTarget)) {
            args.cancel = true;
            return;
        }
        if (this.selectedTarget.classList.contains('e-appointment')) {
            this.menuObj.showItems(['Cut', 'Copy'], true);
            this.menuObj.hideItems(['Paste'], true);
        } else {
            this.menuObj.showItems(['Paste'], true);
            this.menuObj.hideItems(['Cut', 'Copy'], true);
        }
    }

    public onMenuItemSelect(args: MenuEventArgs): void {
        const selectedMenuItem: string = args.item.id as string;
        switch (selectedMenuItem) {
            case 'Cut':
                this.scheduleObj.cut([this.selectedTarget] as HTMLElement[]);
                break;
            case 'Copy':
                this.scheduleObj.copy([this.selectedTarget] as HTMLElement[]);
                break;
            case 'Paste':
                this.scheduleObj.paste(this.targetElement);
                break;
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Modifying content before pasting

You can modify the content of an appointment before pasting it by using beforePaste event accessing the appointment details and making necessary changes.

The following example demonstrates how to seamlessly copy and paste content from a grid to a scheduler. To do this, follow these steps:

  1. Select an Item: Click on an item in the grid.
  2. Copy the Details: Press Ctrl + C to copy the selected event details.
  3. Choose a Time Slot: Click on the desired time slot in the scheduler.
  4. Paste the Details: Press Ctrl + V to paste the copied appointment details into the selected time slot.

In this example, the beforePaste event can be utilized to intercept the event details before they are pasted. This allows you to modify the content as needed. Such modifications could include adjusting the time, adding notes, or altering other specifics of the appointment.

Note: Ensure that the field mapping matches with the fields in the scheduler.

<div class="schedule-container">
    <ejs-schedule #scheduleObj height='550px' [selectedDate]="selectedDate" [allowResizing]="allowResizing"
        [allowDragAndDrop]="allowDragDrop" [eventSettings]="eventSettings" [allowClipboard]="true"
        [showQuickInfo]="false" (beforePaste)="onBeforePaste($event)">
    </ejs-schedule>

    <ejs-grid id="Grid" #gridObj [dataSource]="gridData" width="40%" height="450px" cssClass="drag-grid"
        [allowSelection]="true">
        <e-columns>
            <e-column field="OrderID" headerText="Order ID" textAlign="Right" width="90"></e-column>
            <e-column field="CustomerID" headerText="Customer ID" width="100"></e-column>
            <e-column field="ShipCity" headerText="Ship City" width="100"></e-column>
            <e-column field="ShipName" headerText="Ship Name" width="130"></e-column>
            <e-column field="OrderDate" headerText="Order Date" type="date" format="yMd" width="100"></e-column>
        </e-columns>
    </ejs-grid>
</div>
import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { BeforePasteEventArgs, ScheduleModule } from '@syncfusion/ej2-angular-schedule'
import { ButtonModule } from '@syncfusion/ej2-angular-buttons'
import { ContextMenuModule } from '@syncfusion/ej2-angular-navigations'
import { Component, ViewChild, ViewEncapsulation } from '@angular/core';
import { extend } from '@syncfusion/ej2-base';
import {
    EventSettingsModel, DayService, WeekService, WorkWeekService, MonthService, AgendaService, ScheduleComponent, MonthAgendaService
} from '@syncfusion/ej2-angular-schedule';
import { scheduleData } from './datasource';
import { GridModule } from '@syncfusion/ej2-angular-grids'


interface ScheduleData {
    Id: string;
    Subject: string;
    StartTime: string;
    EndTime: string;
    Location: string;
    Description: string
}

@Component({
    imports: [
        ScheduleModule,
        ButtonModule,
        ContextMenuModule,
        GridModule
    ],
    standalone: true,
    selector: 'app-root',
    templateUrl: './app.component.html',
    providers: [DayService, WeekService, WorkWeekService, MonthService, AgendaService, MonthAgendaService],
    styleUrls: ['./index.css'],
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild('scheduleObj')
    public scheduleObj?: ScheduleComponent;
    public allowResizing: Boolean = false;
    public allowDragDrop: Boolean = false;
    public selectedDate: Date = new Date(2024, 1, 15);
    public eventSettings: EventSettingsModel = { dataSource: <Object[]>extend([], scheduleData, undefined, true) };

    public gridData: Record<string, any>[] = [
        {
            OrderID: 10248, CustomerID: 'VINET', Role: 'Admin', EmployeeID: 5,
            ShipName: 'Vins et alcools Chevalier', ShipCity: 'Reims', ShipAddress: '59 rue de l Abbaye',
            ShipRegion: 'CJ', Mask: '1111', ShipPostalCode: '51100', ShipCountry: 'France', Freight: 32.38, Verified: !0,
            OrderDate: new Date('2024-01-01')
        },
        {
            OrderID: 10249, CustomerID: 'TOMSP', Role: 'Employee', EmployeeID: 6,
            ShipName: 'Toms Spezialitäten', ShipCity: 'Münster', ShipAddress: 'Luisenstr. 48',
            ShipRegion: 'CJ', Mask: '2222', ShipPostalCode: '44087', ShipCountry: 'Germany', Freight: 11.61, Verified: !1,
            OrderDate: new Date('2024-01-02')
        },
        {
            OrderID: 10250, CustomerID: 'HANAR', Role: 'Admin', EmployeeID: 4,
            ShipName: 'Hanari Carnes', ShipCity: 'Rio de Janeiro', ShipAddress: 'Rua do Paço, 67',
            ShipRegion: 'RJ', Mask: '3333', ShipPostalCode: '05454-876', ShipCountry: 'Brazil', Freight: 65.83, Verified: !0,
            OrderDate: new Date('2024-01-03')
        },
        {
            OrderID: 10251, CustomerID: 'VICTE', Role: 'Manager', EmployeeID: 3,
            ShipName: 'Victuailles en stock', ShipCity: 'Lyon', ShipAddress: '2, rue du Commerce',
            ShipRegion: 'CJ', Mask: '4444', ShipPostalCode: '69004', ShipCountry: 'France', Freight: 41.34, Verified: !0,
            OrderDate: new Date('2024-01-04')
        },
        {
            OrderID: 10252, CustomerID: 'SUPRD', Role: 'Manager', EmployeeID: 2,
            ShipName: 'Suprêmes délices', ShipCity: 'Charleroi', ShipAddress: 'Boulevard Tirou, 255',
            ShipRegion: 'CJ', Mask: '5555', ShipPostalCode: 'B-6000', ShipCountry: 'Belgium', Freight: 51.3, Verified: !0,
            OrderDate: new Date('2024-01-05')
        },
        {
            OrderID: 10253, CustomerID: 'HANAR', Role: 'Admin', EmployeeID: 7,
            ShipName: 'Hanari Carnes', ShipCity: 'Rio de Janeiro', ShipAddress: 'Rua do Paço, 67',
            ShipRegion: 'RJ', Mask: '6666', ShipPostalCode: '05454-876', ShipCountry: 'Brazil', Freight: 58.17, Verified: !0,
            OrderDate: new Date('2024-01-06')
        },
        {
            OrderID: 10254, CustomerID: 'CHOPS', Role: 'Employee', EmployeeID: 5,
            ShipName: 'Chop-suey Chinese', ShipCity: 'Bern', ShipAddress: 'Hauptstr. 31',
            ShipRegion: 'CJ', Mask: '7777', ShipPostalCode: '3012', ShipCountry: 'Switzerland', Freight: 22.98, Verified: !1,
            OrderDate: new Date('2024-01-07')
        }

    ]

    public onBeforePaste(args: BeforePasteEventArgs) {
        if (typeof args.data === 'string') {
            const dataArray: string[] = (args.data as string).split('\t');
            const result: ScheduleData = {
                Id: dataArray[0],
                Subject: dataArray[1],
                StartTime: new Date(dataArray[4]).toISOString(),
                EndTime: new Date(new Date(dataArray[4]).getTime() + 60 * 60 * 1000).toISOString(),
                Location: dataArray[2],
                Description: dataArray[3]
            };
            args.data = [result];
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

You can refer to our Angular Scheduler feature tour page for its groundbreaking feature representations. You can also explore our Angular Scheduler example to knows how to present and manipulate data.